package com.eactive.eai.batch.job.jobItem.zeniel;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.batch.scheduler.SchedulerMessageManager;
import com.eactive.eai.batch.scheduler.SchedulerMessageVO;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_ZENEL_0640 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public RECV_ZENEL_0640() {
        //화일정보수신통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String fileInfo = new String ((byte[]) al_Field.get(8));        // 화일정보내역
            long fSize      = Long.parseLong(fileInfo.substring(8, 20));    //화일 size
            int fByte       = Integer.parseInt(fileInfo.substring(20, 24)); //전문 바이트 수

            //TelegramKeys.DATA_BYTE_SIZE는 한번에 파일에서 읽어와 전송할 데이터의 크기
            if (fByte < batchDoc.getBatchMsg().getHeader().getSequenceSize()) {
                //630전문과 640전문의 byte수를 비교하여 작은 값을 설정.
                batchDoc.getBatchMsg().getHeader().setSequenceSize(fByte);
            }

            if (getResCode().equalsIgnoreCase(TelegramKeys.RES_CODE_ALREADY_RECEIVED)
                    ||getResCode().equalsIgnoreCase(TelegramKeys.RES_CODE_NOT_REGISTERED)) { //기송신 파일이면
                checkMoreFileinDB();
            } else {
//                int seqSize = batchDoc.getBatchMsg().getHeader().getSequenceSize();
//                int blockSize = batchDoc.getBatchMsg().getHeader().getBlockSize();
//                int totSeqSizeOffSize = 0;
//                int seqSizeOffSize = 0;
//                int blockSizeOffSize = 0;

                if (fSize > 0) { //기 송신된 파일이면서 미완료 파일이면
//                    totSeqSizeOffSize = (int)fSize / seqSize;
//                    if (totSeqSizeOffSize > 0 ) {   //
//                        blockSizeOffSize = totSeqSizeOffSize /  blockSize;
//                        batchDoc.getBatchMsg().getBody().setCurFileSize(fSize);
//
//                        FileInputStream fin = BatchOpenFileManager.getInstance().getFile(batchDoc.getBatchMsg().getHeader().getUUID() );
//                        if ( blockSizeOffSize > 0) {
//                            long iLoopCnt = blockSizeOffSize * blockSize;
//                            for( int inx = 0; inx < iLoopCnt; inx++){
//                                FileUtil.readLine(fin);
//                            }
//                            batchDoc.getBatchMsg().getBody().setBlockNum(blockSizeOffSize+1);    //기 송신된 블럭 다음부터 송신
//                        } else {
//                            batchDoc.getBatchMsg().getBody().setBlockNum(1);
//                        }
//                        seqSizeOffSize = totSeqSizeOffSize %  blockSize;
//
//                        String header = this.batchDoc.getBatchMsg().getFileHeader();
//                        // 파일에서 읽은 DATA를 추후 결번 재전송을 위해 메모리에 저장해 둔다. 2008.06.19 - 정동한
//                        JobProcessData job = JobProcessData.getInstance();
//                        String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
//                        HashMap<String, Object> hm = job.getBatchStageData(uuid);
//
//                        @SuppressWarnings("unchecked")
//                        HashMap<Integer, byte[]> block_data = (HashMap<Integer, byte[]>) hm.get(JobProcessData.PROCDATA_BLOCKDATA);
//                        if (block_data == null) {
//                            block_data = new HashMap<Integer, byte[]>();
//                        }
//
//                        if (seqSizeOffSize > 0){
//                            for ( int jnx = 0; jnx < seqSizeOffSize; jnx++){
//                                byte[] fileLine = FileUtil.readLine(fin);
//                                int REAL_BYTE = Integer.parseInt(header.substring(23, 27));
//                                byte[] fileData = new byte[REAL_BYTE];
//                                System.arraycopy( fileLine, 7, fileData, 0, REAL_BYTE);
//                                block_data.put( new Integer(jnx), fileData);
//                            }
//                            hm.put(JobProcessData.PROCDATA_BLOCKDATA, block_data);
//                            batchDoc.getBatchMsg().getBody().setSeqNum(seqSizeOffSize);
//                        } else {
//                            batchDoc.getBatchMsg().getBody().setSeqNum(0);
//                        }
//                    }
//                    else {//기전송된 파일의 사이즈가 seqSize보다 작으면 처음부터 다시 송신
//                        batchDoc.getBatchMsg().getBody().setBlockNum(0);
//                        batchDoc.getBatchMsg().getBody().setSeqNum(0);
//                    }
                    setConditionTxt(TelegramKeys.ERROR);
                    throw new Exception("상대 기관에 수신 자료 초기화 요청 바랍니다.");
                } else { //최초 송신이면
                    batchDoc.getBatchMsg().getBody().setBlockNum(0);
                    batchDoc.getBatchMsg().getBody().setSeqNum(0);
                }
            }

        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<8; i++) { //제니엘 CMS전문의 헤더는 응답코드까지 임(TRANSACTION CODE 삭제)
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=8; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            LogUtil.setLogFileStart(batchDoc);

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private void checkMoreFileinDB(){
        String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
        String institutionCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
        SchedulerMessageVO info;

        try{
            info = SchedulerMessageManager.getInstance().getExecutableJobFromQueue(processCode, institutionCode );
            if ( info == null ) {
                return;
            }
            String strUUID = batchDoc.getBatchMsg().getHeader().getUUID();
            String strSubUUID = batchDoc.getBatchMsg().getBody().getSubUUID();

            //해당 작업을 Job_Queue 테이블에서 Job_Processing 테이블로 이동
            SchedulerMessageManager.getInstance().moveJobQueueToHandleWithNewID(info, strUUID, strSubUUID);

            //BatchMsgDoc 값 설정
            batchDoc.getBatchMsg().getHeader().setScheduleCode(info.getScheduleCode());
            batchDoc.getBatchMsg().getHeader().setScheduleSTime(info.getStartTime());
            batchDoc.getBatchMsg().getHeader().setScheduleETime(info.getEndTime());
            batchDoc.getBatchMsg().getHeader().setFilePath(info.getFilePath());
            batchDoc.getBatchMsg().getHeader().setFileName(info.getFileName());
            batchDoc.getBatchMsg().getHeader().setRenamedFileName(info.getRenamedFileName());
            batchDoc.getBatchMsg().getHeader().setJobCode(info.getJobCode());
            // 0600 전문을 보내어 현재 파일을 마무리 하여야 하므로 여기서 BizCode를 세팅하면 안된다.
            //batchDoc.getEAIBatchMessage().getHeader().setBizCode(info.getBizCode());
            batchDoc.getBatchMsg().getHeader().setFlowCode(info.getFlowRuleCode());
            batchDoc.getBatchMsg().getHeader().setRuleCode(info.getFlowRuleCode());
            batchDoc.getBatchMsg().getHeader().setBlockSize(info.getBlockSize());
            batchDoc.getBatchMsg().getHeader().setSequenceSize(info.getSequenceSize());
            batchDoc.getBatchMsg().getHeader().setPacketSize(info.getPacketSize());
            batchDoc.getBatchMsg().getHeader().setUserID(info.getRemoteUserID());
            batchDoc.getBatchMsg().getHeader().setUserPassword(info.getRemoteUserPW());
            batchDoc.getBatchMsg().getHeader().setFileSize(0);
            batchDoc.getBatchMsg().getBody().setCurFileSize(0);
            this.setConditionTxt(TelegramKeys.EOF);

        } catch ( Exception e){
            logger.error( e.getMessage(), e);
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(4);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(7);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}